<?php
/*
 * login_with_dailymotion.php
 *
 * @(#) $Id: login_with_dailymotion.php,v 1.2 2014/04/12 10:24:48 mlemos Exp $
 *
 */

/*
 *  Get the http.php file from http://www.phpclasses.org/httpclient
 */
require('http.php');
require('oauth_client.php');

$client = new oauth_client_class();
$client->debug = true;
$client->debug_http = true;
$client->server = 'Dailymotion';
$client->redirect_uri = 'http://'.$_SERVER['HTTP_HOST'].
    dirname(strtok($_SERVER['REQUEST_URI'], '?')).'/login_with_dailymotion.php';

$client->client_id = '';
$application_line = __LINE__;
$client->client_secret = '';

if (strlen($client->client_id) == 0
|| strlen($client->client_secret) == 0) {
    die('Please go to Dailymotion Apps page http://www.dailymotion.com/profile/developer/new , '.
        'create an application, and in the line '.$application_line.
        ' set the client_id to API Key and client_secret with API Secret');
}

/* API permissions
 */
$client->scope = 'read userinfo email';
if (($success = $client->Initialize())) {
    if (($success = $client->Process())) {
        if (strlen($client->access_token)) {
            $success = $client->CallAPI(
                'https://api.dailymotion.com/user/me?fields=fullname,email',
                'GET',
                array(),
                array('FailOnAccessError'=>true),
                $user
            );
        }
    }
    $success = $client->Finalize($success);
}
if ($client->exit) {
    exit;
}
if ($success) {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Dailymotion OAuth client results</title>
</head>
<body>
<?php
            echo '<h1>', HtmlSpecialChars($user->fullname),
    ' you have logged in successfully with Dailymotion!</h1>';
    echo '<pre>', HtmlSpecialChars(print_r($user, 1)), '</pre>';
    ?>
</body>
</html>
<?php
} else {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>OAuth client error</title>
</head>
<body>
<h1>OAuth client error</h1>
<pre>Error: <?php echo HtmlSpecialChars($client->error); ?></pre>
</body>
</html>
<?php
}

?>