<?php
/*
 * login_with_imgur.php
 *
 * @(#) $Id: login_with_imgur.php,v 1.2 2014/11/14 10:37:51 mlemos Exp $
 *
 */

/*
 *  Get the http.php file from http://www.phpclasses.org/httpclient
 */
require('http.php');
require('oauth_client.php');

$client = new oauth_client_class();
$client->debug = false;
$client->debug_http = true;
$client->server = 'imgur';
$client->redirect_uri = 'http://'.$_SERVER['HTTP_HOST'].
    dirname(strtok($_SERVER['REQUEST_URI'], '?')).'/login_with_imgur.php';

/*
 * Uncomment the next line if you want to use
 * the pin based authorization flow
 */
// $client->redirect_uri = 'oob';

/*
 * Was this script included defining the pin the
 * user entered to authorize the API access?
 */
if (defined('OAUTH_PIN')) {
    $client->pin = OAUTH_PIN;
}

$client->client_id = '';
$application_line = __LINE__;
$client->client_secret = '';

if (strlen($client->client_id) == 0
|| strlen($client->client_secret) == 0) {
    die('Please go to imgur applications page https://api.imgur.com/oauth2/addclient , '.
        'create an application, and in the line '.$application_line.
        ' set the client_id to Client ID and client_secret with Client Secret');
}

/* API permissions
 */
$client->scope = '';
if (($success = $client->Initialize())) {
    if (($success = $client->Process())) {
        if (strlen($client->access_token)) {
            $success = $client->CallAPI(
                'https://api.imgur.com/3/account/me',
                'GET',
                array(),
                array('FailOnAccessError'=>true),
                $user
            );
        }
    }
    $success = $client->Finalize($success);
}
if ($client->exit) {
    exit;
}
if ($success) {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>imgur OAuth client results</title>
</head>
<body>
<?php
            echo '<h1>', HtmlSpecialChars($user->data->url),
    ' you have logged in successfully with imgur!</h1>';
    echo '<pre>', HtmlSpecialChars(print_r($user, 1)), '</pre>';
    ?>
</body>
</html>
<?php
} else {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>OAuth client error</title>
</head>
<body>
<h1>OAuth client error</h1>
<pre>Error: <?php echo HtmlSpecialChars($client->error); ?></pre>
</body>
</html>
<?php
}

?>