<?php
/*
 * login_with_intuit.php
 *
 * @(#) $Id: login_with_intuit.php,v 1.1 2014/10/09 09:06:53 mlemos Exp $
 *
 */

/*
 *  Get the http.php file from http://www.phpclasses.org/httpclient
 */
require('http.php');
require('oauth_client.php');

$client = new oauth_client_class();
$client->debug = 1;
$client->debug_http = 1;
$client->server = 'Intuit';
$client->redirect_uri = 'http://'.$_SERVER['HTTP_HOST'].
    dirname(strtok($_SERVER['REQUEST_URI'], '?')).'/login_with_intuit.php';

$client->client_id = '';
$application_line = __LINE__;
$client->client_secret = '';

if (strlen($client->client_id) == 0
|| strlen($client->client_secret) == 0) {
    die('Please go to Intuit Developer page https://developer.intuit.com/ , '.
        'create an application in the My Apps menu, and in the line '.$application_line.
        ' set the client_id to Consumer Key and client_secret with Consumer Secret. '.
        'The Callback URL must be '.$client->redirect_uri.' If you want to post to '.
        'the user timeline, make sure the application you create has write permissions');
}

if (($success = $client->Initialize())) {
    if (($success = $client->Process())) {
        if (strlen($client->access_token)) {
            $success = $client->CallAPI(
                'https://appcenter.intuit.com/api/v1/user/current?format=json',
                'GET',
                array(),
                array('FailOnAccessError'=>true),
                $user
            );
        }
    }
    $success = $client->Finalize($success);
}
if ($client->exit) {
    exit;
}
if ($success) {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Intuit OAuth client results</title>
</head>
<body>
<?php
            echo '<h1>', HtmlSpecialChars($user->User->FirstName),
    ' you have logged in successfully with Intuit!</h1>';
    echo '<pre>', HtmlSpecialChars(print_r($user, 1)), '</pre>';
    ?>
</body>
</html>
<?php
} else {
    ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>OAuth client error</title>
</head>
<body>
<h1>OAuth client error</h1>
<pre>Error: <?php echo HtmlSpecialChars($client->error); ?></pre>
</body>
</html>
<?php
}

?>