<?php
/**
 * This code is licensed under AGPLv3 license or Afterlogic Software License
 * if commercial version of the product was purchased.
 * For full statements of the licenses see LICENSE-AFTERLOGIC and LICENSE-AGPL3 files.
 */

namespace Afterlogic\DAV\FS\Local\Personal;

/**
 * @license https://www.gnu.org/licenses/agpl-3.0.html AGPL-3.0
 * @license https://afterlogic.com/products/common-licensing Afterlogic Software License
 * @copyright Copyright (c) 2019, Afterlogic Corp.
 */
class File extends \Afterlogic\DAV\FS\Local\File
{
    public function __construct($path)
    {
        parent::__construct(\Aurora\System\Enums\FileStorageType::Personal, $path);
    }

    public function delete()
    {
        $result = parent::delete();

        $this->updateUsedSpace();

        return $result;
    }

    public function put($data)
    {
        $result = parent::put($data);

        $this->updateUsedSpace();

        return $result;
    }
}
