<?php
/**
 * This code is licensed under AGPLv3 license or Afterlogic Software License
 * if commercial version of the product was purchased.
 * For full statements of the licenses see LICENSE-AFTERLOGIC and LICENSE-AGPL3 files.
 */

namespace MailSo\Mime;

/**
 * @license https://www.gnu.org/licenses/agpl-3.0.html AGPL-3.0
 * @license https://afterlogic.com/products/common-licensing Afterlogic Software License
 * @copyright Copyright (c) 2019, Afterlogic Corp.
 *
 * @category MailSo
 * @package Mime
 */
class AttachmentCollection extends \MailSo\Base\Collection
{
    /**
     * @access protected
     */
    protected function __construct()
    {
        parent::__construct();
    }

    /**
     * @return \MailSo\Mime\AttachmentCollection
     */
    public static function NewInstance()
    {
        return new self();
    }

    /**
     * @return array
     */
    public function LinkedAttachments()
    {
        return $this->FilterList(function ($oItem) {
            return $oItem && $oItem->IsLinked();
        });
    }

    /**
     * @return array
     */
    public function UnlinkedAttachments()
    {
        return $this->FilterList(function ($oItem) {
            return $oItem && !$oItem->IsLinked();
        });
    }

    /**
     * @return int
     */
    public function SizeOfAttachments()
    {
        $iResult = 0;
        $this->ForeachList(function ($oItem) use (&$iResult) {
            if ($oItem) {
                $iResult += $oItem->fileSize();
            }
        });

        return $iResult;
    }
}
